//================================================================================================================
// [mk_extdef.h] :    mk ̺귯 caller α׷  ؾϴ  ǵ 
//  ̴. mk_common.h  ͵  ý  ϴ ε Ͽ, ⿡  
// ǵ ýۿ    ʿ  ̴.
// - Version: 1.02
// - Update Data: 2007/05/08
// - Created by OYS
// -. Revision history:
//   <Ver 1.02>: [2008/12/13] 
//    1) SOCK_BUF_SIZE  EIP2 1024 ÷ȴ("#define SOCK_BUF_SIZE 1024")
//================================================================================================================

#ifndef _MICOMMON_EXTERNAL_DEFINES_H_ //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ #0
#define _MICOMMON_EXTERNAL_DEFINES_H_

//#define START_SECT_IDX	2 // Ʈδ  standalone  ۽ 2(User )  ϵ մϴ.
#define START_SECT_IDX	0 // Ʈδ ƴ  ٿδ  մϴ.  Ʈδ ڵ带 ٿε ֱ ؼ Ʈδ   (0 ~ 1) ͸ մϴ.

#include "mk_common.h"

//#define _OPT_CEIP_SUPPORT  // CEIP  Լ    ּ  

#define AM_SWITCH	0xA0100000	// IP Addr Lotary switch
#define AM_FLASH	0x90000000
#define AM_RS232	0xA0000000
#define AM_ETHER	0xA0080000
#define AM_EBUS		0xB0000000
#define AM_SLOT_ADDR_OFS	0x1000	// ġ ĵ   Ը ּҰ 
#define NUM_MAX_COMMMODULE		10 // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_MOTIONMODULE	10 // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_AXES_PERMOD		2	//   ϳ ִ  2.
#define NUM_MAX_DIOMODULE		10 // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_CNDIOMODULE		10 // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_AIOMODULE		10 // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_CNTMODULE		10 // Up ī ,  // 0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define NUM_MAX_SERMODULE		10 // Ȯ Serial ,  0 base (Idx)  1 base (ID)  ̹Ƿ 9 ƴ 10 ũ .
#define MAX_N_AXES	32 // defines for motion control
#define MAX_N_DIO_CHAN	256 // maximum number of DIO channels

#define FW_VERSION		0x01100318 //  ڸ(Major Version(1~99+): 0108,  ڸ(Minor;) : 0530
#define FLS_SYSTEM_CFG	0 // [FIXME-EIP2]
#define FW_UPDATE_CHECKSIGN	"FLASDONE" // 8 bytes .
#define FW_PORT 		35040 	//  Ʈ ȣ
#define FW_CHANNEL		0		//   ä ȣ.
#define FLS_USER_SECT_IDX	2 		//  Flash ʹ 2  ..
#define FLS_SYS_SECT_IDX	33		// ý  Flash ʹ 33 ϳ.

#define NUM_SERIAL_PORTS	1   // number of serial ports
#if	(_PLATFORM==PLF_EtherIP_2)
 #define SOCK_BUF_SIZE		1024
#else
 #define SOCK_BUF_SIZE		512
#endif

#define MAX_USERCOMMENT_BYTES 32	// ִ  ڸƮ Ʈ=32Ʈ

typedef enum _TLEDStatus{
	ALED_OFF=0, ALED_SS, ALED_LSS, ALED_LL, ALED_ON, ELED_OFF=8, ELED_SS, ELED_LSS, ELED_LL, ELED_ON
}TLEDStatus;

// LED  켱  ε List
typedef enum _TLEDStatusIdx{
	LEDSIDX_NM_DISABLE=1, LEDSIDX_NM_DUPID, LEDSIDX_NM_WRONGID, LEDSIDX_NM_FWUP,
	LEDSIDX_MO_DISABLE, LEDSIDX_MO_WRONGID, LEDSIDX_MO_COMMERR, LEDSIDX_MO_COMMOK, LEDSIDX_MO_RDY
}TLEDStatusIdx;

typedef enum { CPU_MODULE_ERR, CPU_MODULE_ACT, DIO_MODULE_ERR, DIO_MODULE_ACT, AI_MODULE_ERR, AI_MODULE_ACT, AO_MODULE_ERR, AO_MODULE_ACT, CNT_MODULE_ERR, CNT_MODULE_ACT, SER_MODULE_ERR, SER_MODULE_ACT, CNDIO_MODULE_ERR, CNDIO_MODULE_ACT } LED_TYPE;

typedef struct{
	t_ui32 Min: 16;
	t_ui32 Maj: 16;
}TVersion; //   ڰ ڱ⸸    ֵ  ̴.

typedef struct{
	t_ui32 dwSign;
	TVersion SysVer; 
	TSockAddr IpAddr;
	TVersion UserVer;
	t_ui32 dwComment[8]; // [5]->[8] . ڰ ʿ ڸƮ   ֵ (4byte*8=32)
	t_ui32 dwCommentCnt;
	t_ui32 dwReserved[10]; // [14]->[10] 
}TSysConfig;

// mk_extern.c
unsigned char GetLastIpAddrFromGPIOF();
t_ui32 mkcTimerTick(void);

#if 1
t_bool mkLoadSysCfg(void);
t_i32 mkSaveSysCfg(void);
void SetLEDStatusIdx(t_ui16 uLEDStatusIdx, t_bool bUpdateOnce);
//void UpdateLEDStatus();
void SetLED(t_i32 nType, long nModIdx, unsigned long hDevice, t_i32 bOn);

t_bool siGetOne(t_ui32 nChannel);
t_i32 siGetMulti(t_ui32 nIniChan, t_ui32 nNumChan);
void soPutOne(t_ui32 nChannel, t_bool bState);
t_bool soGetOne(t_ui32 nChannel);
void soPutMulti(t_ui32 nIniChan, t_ui32 nNumChan, t_ui32 dwStates);
t_i32 soGetMulti(t_ui32 nIniChan, t_ui32 nNumChan);
#endif

// FW_UPGRADE.lib
t_bool FW_MainLoop();
t_ui32 FW_GetVersion();

// Gpio.lib
extern void Act_LED_On(t_byte On);
extern void Err_LED_On(t_byte On);
extern t_i32 GetSerDigInput(t_i8 ch);

#endif //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ #0
